'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Menubar = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _DomHandler = require('../utils/DomHandler');

var _DomHandler2 = _interopRequireDefault(_DomHandler);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenubarSub = function (_Component) {
    _inherits(MenubarSub, _Component);

    function MenubarSub(props) {
        _classCallCheck(this, MenubarSub);

        var _this = _possibleConstructorReturn(this, (MenubarSub.__proto__ || Object.getPrototypeOf(MenubarSub)).call(this, props));

        _this.state = {
            activeItem: null
        };
        return _this;
    }

    _createClass(MenubarSub, [{
        key: 'onItemMouseEnter',
        value: function onItemMouseEnter(event, item) {
            if (item.disabled) {
                event.preventDefault();
                return;
            }

            if (this.props.root) {
                if (this.state.activeItem) {
                    this.setState({
                        activeItem: item
                    });
                }
            } else {
                this.setState({
                    activeItem: item
                });
            }
        }
    }, {
        key: 'onItemClick',
        value: function onItemClick(event, item) {
            if (item.disabled) {
                event.preventDefault();
                return;
            }

            if (!item.url) {
                event.preventDefault();
            }

            if (item.command) {
                item.command({
                    originalEvent: event,
                    item: item
                });
            }

            if (this.props.root) {
                if (item.items) {
                    if (this.state.activeItem) {
                        this.setState({
                            activeItem: null
                        });
                    } else {
                        this.setState({
                            activeItem: item
                        });
                    }
                }
            }

            if (!item.items) {
                this.props.onLeafClick(event);
            }
        }
    }, {
        key: 'renderSeparator',
        value: function renderSeparator(index) {
            return _react2.default.createElement('li', { key: 'separator_' + index, className: 'p-menu-separator' });
        }
    }, {
        key: 'renderIcon',
        value: function renderIcon(item) {
            var className = (0, _classnames2.default)('p-menuitem-icon', item.icon);
            if (item.icon) {
                return _react2.default.createElement('span', { className: className });
            } else {
                return null;
            }
        }
    }, {
        key: 'renderSubmenuIcon',
        value: function renderSubmenuIcon(item) {
            var icon = (0, _classnames2.default)('p-submenu-icon pi pi-fw', { 'pi-caret-down': this.props.root, 'pi-caret-right': !this.props.root });

            if (item.items) {
                return _react2.default.createElement('span', { className: icon });
            } else {
                return null;
            }
        }
    }, {
        key: 'renderSubmenu',
        value: function renderSubmenu(item) {
            if (item.items) {
                return _react2.default.createElement(MenubarSub, { model: item.items, resetMenu: item !== this.state.activeItem, onLeafClick: this.props.onLeafClick });
            } else {
                return null;
            }
        }
    }, {
        key: 'renderMenuitem',
        value: function renderMenuitem(item, index) {
            var _this2 = this;

            var className = (0, _classnames2.default)('p-menuitem', { 'p-menuitem-active': this.state.activeItem === item, 'p-disabled': item.disabled }, item.className);
            var icon = this.renderIcon(item);
            var submenuIcon = this.renderSubmenuIcon(item);
            var submenu = this.renderSubmenu(item);

            return _react2.default.createElement(
                'li',
                { key: item.label + '_' + index, className: className, style: item.style, onMouseEnter: function onMouseEnter(event) {
                        return _this2.onItemMouseEnter(event, item);
                    } },
                _react2.default.createElement(
                    'a',
                    { href: item.url || '#', className: 'p-menuitem-link', target: item.target, onClick: function onClick(event) {
                            return _this2.onItemClick(event, item, index);
                        } },
                    icon,
                    _react2.default.createElement(
                        'span',
                        { className: 'p-menuitem-text' },
                        item.label
                    ),
                    submenuIcon
                ),
                submenu
            );
        }
    }, {
        key: 'renderItem',
        value: function renderItem(item, index) {
            if (item.separator) return this.renderSeparator(index);else return this.renderMenuitem(item, index);
        }
    }, {
        key: 'renderMenu',
        value: function renderMenu() {
            var _this3 = this;

            if (this.props.model) {
                return this.props.model.map(function (item, index) {
                    return _this3.renderItem(item, index);
                });
            } else {
                return null;
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var className = (0, _classnames2.default)({ 'p-submenu-list': !this.props.root, 'p-menubar-root-list': this.props.root });
            var submenu = this.renderMenu();

            return _react2.default.createElement(
                'ul',
                { className: className },
                submenu
            );
        }
    }], [{
        key: 'getDerivedStateFromProps',
        value: function getDerivedStateFromProps(nextProps, prevState) {
            if (nextProps.resetMenu === true) {
                return {
                    activeItem: null
                };
            }

            return null;
        }
    }]);

    return MenubarSub;
}(_react.Component);

MenubarSub.defaultProps = {
    model: null,
    root: false,
    className: null,
    resetMenu: false,
    onLeafClick: null
};
MenubarSub.propTypes = {
    model: _propTypes2.default.any,
    root: _propTypes2.default.bool,
    className: _propTypes2.default.string,
    resetMenu: _propTypes2.default.bool,
    onLeafClick: _propTypes2.default.func
};

var Menubar = exports.Menubar = function (_Component2) {
    _inherits(Menubar, _Component2);

    function Menubar(props) {
        _classCallCheck(this, Menubar);

        var _this4 = _possibleConstructorReturn(this, (Menubar.__proto__ || Object.getPrototypeOf(Menubar)).call(this));

        _this4.state = {
            resetMenu: false
        };
        _this4.onMenuClick = _this4.onMenuClick.bind(_this4);
        _this4.onLeafClick = _this4.onLeafClick.bind(_this4);
        return _this4;
    }

    _createClass(Menubar, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.bindDocumentClickListener();
        }
    }, {
        key: 'onMenuClick',
        value: function onMenuClick() {
            this.selfClick = true;

            this.setState({
                resetMenu: false
            });

            if (this.props.autoZIndex) {
                this.container.style.zIndex = String(this.props.baseZIndex + _DomHandler2.default.generateZIndex());
            }
        }
    }, {
        key: 'onLeafClick',
        value: function onLeafClick(event) {
            this.setState({
                resetMenu: true
            });

            event.stopPropagation();
        }
    }, {
        key: 'bindDocumentClickListener',
        value: function bindDocumentClickListener() {
            var _this5 = this;

            if (!this.documentClickListener) {
                this.documentClickListener = function (event) {
                    if (!_this5.selfClick) {
                        _this5.setState({
                            resetMenu: true
                        });
                    }

                    _this5.selfClick = false;
                };

                document.addEventListener('click', this.documentClickListener);
            }
        }
    }, {
        key: 'unbindDocumentClickListener',
        value: function unbindDocumentClickListener() {
            if (this.documentClickListener) {
                document.removeEventListener('click', this.documentClickListener);
                this.documentClickListener = null;
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.unbindDocumentClickListener();
        }
    }, {
        key: 'renderCustomContent',
        value: function renderCustomContent() {
            if (this.props.children) {
                return _react2.default.createElement(
                    'div',
                    { className: 'p-menubar-custom' },
                    this.props.children
                );
            } else {
                return null;
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this6 = this;

            var className = (0, _classnames2.default)('p-menubar p-component', this.props.className);
            var customContent = this.renderCustomContent();

            return _react2.default.createElement(
                'div',
                { id: this.props.id, className: className, style: this.props.style, onClick: this.onMenuClick, ref: function ref(el) {
                        return _this6.container = el;
                    } },
                _react2.default.createElement(MenubarSub, { model: this.props.model, root: true, resetMenu: this.state.resetMenu, onLeafClick: this.onLeafClick }),
                customContent
            );
        }
    }]);

    return Menubar;
}(_react.Component);

Menubar.defaultProps = {
    id: null,
    model: null,
    style: null,
    className: null,
    autoZIndex: true,
    baseZIndex: 0
};
Menubar.propTypes = {
    id: _propTypes2.default.string,
    model: _propTypes2.default.array,
    style: _propTypes2.default.object,
    className: _propTypes2.default.string,
    autoZIndex: _propTypes2.default.bool,
    baseZIndex: _propTypes2.default.number
};